About TurboVNC
==============

Virtual Network Computing (VNC) is a remote display system that allows you to
view and interact with a desktop environment that is running on a remote
computer.  Using VNC, you can run graphical applications on a remote machine
and send only the pixels generated by those applications to your local machine.
VNC is platform-independent and supports a wide variety of operating systems
and architectures as both servers and clients.

TurboVNC is a high-speed version of VNC derived from TightVNC.  It contains
a variant of Tight encoding that is tuned to maximize performance for
image-intensive applications (such as VirtualGL, video applications, and image
editors) while still providing excellent performance for other types of
applications.  TurboVNC, in combination with VirtualGL, provides a complete
solution for remotely displaying 3D applications with interactive performance.

Refer to the TurboVNC User's Guide and man pages for a more thorough
description of the components that make up TurboVNC.

More information about TurboVNC can be found at <https://TurboVNC.org>.


Funding
=======

TurboVNC is an independent open source project, but we rely on patronage and
funded development in order to maintain that independence.  The easiest way to
ensure that TurboVNC remains community-focused and free of any one
organization's agenda is to
[sponsor our project through GitHub](https://github.com/sponsors/TurboVNC).
All sponsorship money goes directly toward funding the labor necessary to
maintain TurboVNC, support the user community, and implement bug fixes and
strategically important features.

[![Sponsor TurboVNC](https://img.shields.io/github/sponsors/TurboVNC?label=Sponsor&logo=GitHub)](https://github.com/sponsors/TurboVNC)


Legal
=====

TurboVNC is

    Copyright (C) 2009-2025 D. R. Commander
    Copyright (C) 2021 Steffen Kieß
    Copyright (C) 2011-2019 Brian P. Hinz
    Copyright (C) 2010 University Corporation for Atmospheric Research
    Copyright (C) 2004-2008 Sun Microsystems, Inc.
    Copyright (C) 2004 Landmark Graphics Corporation

TurboVNC contains code from LibVNCServer, RealVNC, TigerVNC, and TightVNC,
which are

    Copyright (C) 2009-2021 Pierre Ossman for Cendio AB
    Copyright (C) 2005-2011 Martin Koegler
    Copyright (C) 2010-2011 Joel Martin
    Copyright (C) 2011 Gernot Tenchio
    Copyright (C) 2010 m-privacy GmbH
    Copyright (C) 2010 TigerVNC Team
    Copyright (C) 2004-2009 Red Hat, Inc.
    Copyright (C) 2009 TightVNC Team
    Copyright (C) 2000-2006 Constantin Kaplinsky
    Copyright (C) 2006 OCCAM Financial Technology
    Copyright (C) 2002-2005 RealVNC Ltd.
    Copyright (C) 2004-2005 Cendio AB
    Copyright (C) 2003 Sun Microsystems, Inc.
    Copyright (C) 2000 Tridia Corp.
    Copyright (C) 1999 AT&T Laboratories Cambridge.

This software is distributed under the GNU General Public Licence as published
by the Free Software Foundation.  See the file [LICENSE.txt](LICENSE.txt) for
the conditions under which this software is made available.  TurboVNC also
contains code from other sources.  See the individual source files for details
of the conditions under which they are made available.
